import { Context } from 'koa';
import services from '../services';

export interface InterfaceDocument {
  method: number
  title: string
  url: string
  requestList: InterfaceRequestList[]
}
interface InterfaceRequestList {
  title: string
  type: string
  require: boolean
  defaultValue?: string
  content?: string
}

export const putDocument = async (ctx: Context) => {
  const { method, title, url, requestList = [] }: InterfaceDocument = ctx.request.body;
  if (!method || !title || !url) {
    ctx.status = 400;
    ctx.body = ctx.$response(null, '必填项参数缺失', false, 400000);
    return
  }
  const errorRequestList = requestList.filter(el => (!el.title || !el.type));
  console.log(errorRequestList);
  if (errorRequestList.length) {
    ctx.status = 400;
    ctx.body = ctx.$response(null, '必填项参数缺失', false, 400000);
    return
  }
  const data = await services.document.putDocument(ctx, ctx.request.body)
  ctx.body = ctx.$response(data.data, data.message, data.success, data.code)
};

// export const getDocument = async (ctx:Context) => {
//   const { id } = ctx.query
// }

export default {
  putDocument
}
