import { Context } from 'koa';
import { InterfaceResponseData } from '@utils/response';
import { InterfaceDocument } from '@/controllers/document';
import CODE from '@utils/code';

const putDocument = async (ctx: Context, params: InterfaceDocument) :Promise<InterfaceResponseData> => {
  return new Promise(resolve => {
    const reData: InterfaceResponseData = {
      data: null,
      message: '',
      success: false,
      code: 400000
    }
    ctx.$db.doc.findOne({ url: params.url }, (err, findDoc) => {
      if (err) {
        ctx.$log.error(err)
        ctx.status = 500
        return
      }
      if (findDoc) {
        reData.message = 'url已存在'
        reData.code = CODE.EXIST_PARAMS
        resolve(reData)
        return
      }
      ctx.$db.doc.insert(params, (err, saveDoc) => {
        if (err) {
          ctx.$log.error(err)
          ctx.status = 500
          return
        }
        reData.data = saveDoc;
        reData.message = '保存成功'
        reData.success = true
        reData.code = CODE.SUCCESS
        resolve(reData)
      })
    })
  })
};

export default {
  putDocument
}
